<?php

/* 
 * Actualiza reposición
 */
$pag = "../asignacion_crear.php";
$ruta = "../";
require_once "../class/c_login.php";

define("COORDINADOR", 9);
define("ENVIO_CORREOS", true);

// check if the session is started
if (!isset($_SESSION['user']))
    die('No se ha iniciado sesión');


$user = unserialize($_SESSION['user']);


/*if(!isset($_POST["id"]) || !isset($_POST["fecha_falta"]) || !isset($_POST["fecha_inicial"]) || !isset($_POST["hora_ini"]) || !isset($_POST["min_ini"]) || !isset($_POST["materia"]) || !isset($_POST["grupo"])){
    header("Location: ".$pag."?error=0");
    exit();
}*/

$id = filter_input(INPUT_POST, "id", FILTER_SANITIZE_NUMBER_INT);//limpia texto
$duracion_id = filter_input(INPUT_POST, "duracion", FILTER_SANITIZE_NUMBER_INT);//Id reposicion
$fecha = trim(htmlspecialchars($_POST["fecha_inicial"], ENT_QUOTES, "UTF-8"));//limpia texto
$hora_ini = filter_input(INPUT_POST, "hora_ini", FILTER_SANITIZE_NUMBER_INT);//limpia texto
$min_ini = filter_input(INPUT_POST, "min_ini", FILTER_SANITIZE_NUMBER_INT);//limpia texto
$alumnos = filter_input(INPUT_POST, "alumnos", FILTER_SANITIZE_NUMBER_INT);//limpia texto
$aula = filter_input(INPUT_POST, "aula", FILTER_SANITIZE_NUMBER_INT);//1 regular , 2 sala computo, 3 otro facultad

if(empty($_POST["prof"]))
    $prof = $user["id"];
else
    $prof = filter_input(INPUT_POST, "prof", FILTER_SANITIZE_NUMBER_INT);//limpia texto

//if(isset($_POST["salon"]) && $_POST["salon"] != "")
//$salon = trim(filter_input(INPUT_POST, "salon", FILTER_SANITIZE_STRING,array('flags' => FILTER_FLAG_STRIP_LOW)));//limpia texto
$comentario = trim(htmlspecialchars($_POST["comentario"], ENT_QUOTES, "UTF-8"));//limpia texto

$duracion_rs = $db->querySingle("select * from duracion where duracion_id = :id", [":id"=>$duracion_id]);
$duracion_tiempo = $duracion_rs["duracion_interval"];



$hora = $hora_ini.":".$min_ini.":00";
$fecha_new =  DateTime::createFromFormat('d/m/Y', $fecha)->format('Y-m-d')." ".$hora;
$fecha_fin_new = date("Y-m-d", strtotime($fecha_new))." ".$duracion_tiempo;
$dia_new = date('w', strtotime($fecha_new));

//echo $fecha_new."<br>";
//echo $fecha_fin_new."<br>";
$fac_rs = $db->querySingle("SELECT facultad_nombre, clave_dependencia from facultad where facultad_id = :id_fac",[':id_fac' => $user->facultad["facultad_id"]] );

$salon_desc = "Pendiente";
if(!empty($salon)){
    $salon_rs = $db->querySingle('SELECT s.salon_id, s.salon_array FROM salon_view s where s.salon_id  = :id_salon',
            [':id_salon' => $salon]
        );
    if($salon_rs["salon_id"] == "" || $salon_rs["salon_id"] == NULL){
        $salon_desc = "Pendiente";
    }else{
        $salon_json = json_decode($salon_rs["salon_array"], true);
        if($salon_json[0]== "UNIVERSIDAD LA SALLE"){
            unset($salon_json[0]);
        }
        $salon_desc = join(" / ",$salon_json);
    }
}

//Obtiene correos
$correos_rs = $db->query('SELECT coor.usuario_correo as coordinador_correo 
        from reposicion_solicitud rs 
        inner join profesor p on rs.profesor_id =p.profesor_id 
        inner join usuario u on u.usuario_id = rs.usuario_id
        inner join horario_view hv on hv.horario_id  = rs.horario_id 
        inner join usuario coor on hv.facultad_id = coor.facultad_id and coor.rol_id = :rol_coord
        where hv.facultad_id = :id_fac',
            [':rol_coord' => COORDINADOR, ':id_fac' => $user->facultad["facultad_id"]]
        );
$coord_correos=[];
foreach($correos_rs as $correo){
    if( count($coord_correos)==0 && $correo["coordinador_correo"]!=""){
        if(!isset($coord_correos["correo"]) || !in_array($correo["coordinador_correo"], $coord_correos["correo"])){
            array_push($coord_correos, $correo["coordinador_correo"]);
        }
    }
}

$correosSup_rs = $db->querySingle("SELECT DISTINCT sup.usuario_correo as coordinador_correo
    FROM horario_supervisor hs
    inner join usuario sup on sup.usuario_id =hs.usuario_id 
    where :id_fac = ANY(hs.facultad_id_array)
        and sup.usuario_correo is not null and sup.usuario_correo != ''",
    [':id_fac' => $user->facultad["facultad_id"]] );


//Valida que profesor no este en 2 reposiciones al mismo tiempo
$traslape = $db->querySingle('SELECT * from traslape_profesor_reposicion(:prof, :fecha, :hora, :dur, :id)',
[':prof' => $prof, ':fecha'=>DateTime::createFromFormat('d/m/Y', $fecha)->format('Y-m-d'), ':hora'=>$hora, ':dur'=>$duracion_tiempo, ':id'=>$id]
)["traslape_profesor_reposicion"];
echo "SELECT * from traslape_profesor_reposicion($prof, '".DateTime::createFromFormat('d/m/Y', $fecha)->format('Y-m-d')."', $hora, $duracion_tiempo, $id)";
if($traslape){
    //header("Location:".$pag."?error=9");
    echo "traslape";
    exit();
}


/*
$log = new LogActividad();
$desc_log = "Actualiza reposición ID[".$id."] Fechas[".$fecha_ini."][".$fecha_fin."] Periodo[".$_SESSION["periodo_id"]."] Materia[".$materia."] Profesor[".$prof."] Salon[".$salon."] Horario[".$hor."]";
$log->appendLog($_SESSION["usuario_id"], $_SESSION["usuario_nombre"]." ".$_SESSION["usuario_apellidos"], $desc_log);*/

try{
    $db->query('SELECT * from fu_asignacion_solicitud(:id, :f_nueva, :hora_nueva, NULL, NULL, :desc, :alumnos, :aula, :duracion, NULL)',
        [':id'=> $id, ':f_nueva' => $fecha_new, ':hora_nueva' => $hora,
        ':desc' => $comentario, ':alumnos' => $alumnos, ':aula' => $aula, ':duracion' => $duracion_tiempo
        ]
    );
}catch(Exception $e){
    //header("Location: ".$pag."?error=2");
    print_r($e->getMessage());
    echo "SELECT * from fu_asignacion_solicitud(:id, :f_nueva, :hora_nueva, NULL, NULL, :desc, :alumnos, :aula, :duracion, NULL)'";
    print_r(
        [':id'=> $id, ':f_nueva' => $fecha_new, ':hora_nueva' => $hora,
        ':desc' => $comentario, ':alumnos' => $alumnos, ':aula' => $aula, ':duracion' => $duracion_tiempo
    ]);
    exit();
}
header("Location: ".$pag);
exit();
?>
